local ADDON_NAME = "CrystalFragmentsDisplay"

local offset = 1
local lastUpdateTime = 0
local timePassed = 0
local slotIndex = 0
local recentCost = 0
local actualCost = 0

function CrFD_AddonOnLoaded(eventCode, addonName)

	if addonName == ADDON_NAME then
	
		if(not GetUnitClassId("Player") == 2) then return end
		
		EVENT_MANAGER:RegisterForEvent(ADDON_NAME, EVENT_ACTION_SLOT_UPDATED, CrFD_ActionSlotUpdated)
		CrFD_CheckHotbar()
		
	end
	
end

function CrFD_ActionSlotUpdated(slotNum)
	CrFD_CheckHotbar()
end

function CrFD_CheckHotbar()
	local slotName = ""
	slotIndex = 0
	for i = 3,7 do
		slotName = GetSlotName(i)
		if slotName == GetAbilityName(46324) then
			slotIndex = i
		end
	end
	if slotIndex == 0 then
		CrFD_Glow:SetHidden(true)
	elseif slotIndex == 3 then
		CrFD_Glow:SetParent(ActionButton3)
		CrFD_Glow:SetAnchor(CENTER, ActionButton3, CENTER, offset, offset)
	elseif slotIndex == 4 then
		CrFD_Glow:SetParent(ActionButton4)
		CrFD_Glow:SetAnchor(CENTER, ActionButton4, CENTER, offset, offset)
	elseif slotIndex == 5 then
		CrFD_Glow:SetParent(ActionButton5)
		CrFD_Glow:SetAnchor(CENTER, ActionButton5, CENTER, offset, offset)
	elseif slotIndex == 6 then
		CrFD_Glow:SetParent(ActionButton6)
		CrFD_Glow:SetAnchor(CENTER, ActionButton6, CENTER, offset, offset)
	elseif slotIndex == 7 then
		CrFD_Glow:SetParent(ActionButton7)
		CrFD_Glow:SetAnchor(CENTER, ActionButton7, CENTER, offset, offset)
	end
end

function CrFD_OnUpdate()

	if(not GetUnitClassId("Player") == 2) then return end

	if slotIndex ~= 0 then
		timePassed = GetGameTimeMilliseconds() - lastUpdateTime
		if timePassed > 333 then	
			lastUpdateTime = GetGameTimeMilliseconds()
			actualCost = GetSlotAbilityCost(slotIndex)
			if actualCost <= (recentCost + 1) / 2 then
				CrFD_Glow:SetHidden(false)
			else
				CrFD_Glow:SetHidden(true)
				recentCost = actualCost
			end		
			--CHAT_SYSTEM:AddMessage("passed " .. timePassed .. " recentCost " .. recentCost .. " actualCost " .. actualCost .. " index " .. slotIndex)
		end
	end
end

EVENT_MANAGER:RegisterForEvent(ADDON_NAME, EVENT_ADD_ON_LOADED, CrFD_AddonOnLoaded)